#!/bin/bash

###############################################################################
# Symantec Copyright Information
###############################################################################

# Copyright (c) 2013 Symantec Corporation. All rights reserved.

# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF SYMANTEC
# CORPORATION. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED WITHOUT THE PRIOR
# EXPRESS WRITTEN PERMISSION OF SYMANTEC CORPORATION.

# The Licensed Software and Documentation are deemed to be commercial computer
# software as defined in FAR 12.212 and subject to restricted rights as
# defined in FAR Section 52.227-19 "Commercial Computer Software -
# Restricted Rights" and DFARS 227.7202, "Rights in Commercial Computer Software
# or Commercial Computer Software Documentation", as applicable, and any
# successor regulations.  Any use, modification, reproduction release,
# performance, display or disclosure of the Licensed Software and Documentation
# by the U.S. Government shall be solely in accordance with the terms of this
# Agreement.

###############################################################################

## Author - Vighnesh Nayak

cmdline_arg_string=$*
argn=0;
PATCH_DIR_NAME=hf_11_0_546_10000
REGREQ=`echo $cmdline_arg_string | grep -c ",[ ]*13[ ]*," ` 

if [ $# -eq 0 ]; then
	echo "*** Usage ***" 
	echo "## ./patch.sh <esmsetup commandline options>"
	echo "All command line arguments required by 'esmsetup' for complete installation must be passed to 'patch.sh'."
	echo "Please refer to esmsetup usage for more information."
	echo ""
	exit -1;

fi

#echo "REGREQ - " $REGREQ
#echo "Arguments passed " $cmdline_arg_string;

cmdline_arg_WOREG_string=`echo $cmdline_arg_string | sed -e 's/13//'` 

#echo "Arguments without registration  " $cmdline_arg_WOREG_string;

echo "Patch process started..."
echo "Launching setup from $PATCH_DIR_NAME..."
$PATCH_DIR_NAME/esmsetup $cmdline_arg_WOREG_string

echo "deploying patches..."

cp -rf $PATCH_DIR_NAME/esmsetup /esm/bin/`/esm/platform`/
cp -rf $PATCH_DIR_NAME/register /esm/bin/`/esm/platform`/
cp -rf $PATCH_DIR_NAME/assetinfo /esm/bin/`/esm/platform`/

if [ $REGREQ -eq 0 ]; then
	echo "Patch process complete."
	exit 0;
fi

ManagerName=
ManagerUser=
ManagerPassword=
AgentName=
AssetID=
VerifyOption=
value=0;

for i in $*; do 
	if [ "$i" == "-M" ]; then
		value=$[$argn+2]
		ManagerName="-m ${!value}"
	elif [ "$i" == "-W" ]; then
		value=$[$argn+2]
		ManagerPassword="-P ${!value}"
	elif [ "$i" == "-U" ]; then
		value=$[$argn+2]
		ManagerUser="-U ${!value}"
	elif [ "$i" == "-N" ]; then
		value=$[$argn+2]
		AgentName="-N ${!value}"
	elif [ "$i" == "-I" ]; then
		value=$[$argn+2]
		AssetID="-I  ${!value}"
	elif [ "$i" == "-E" ]; then
		VerifyOption="-E"
		argn=$[$argn+1];
	fi
		argn=$[$argn+1];
done
#echo "Manager Name " $ManagerName
#echo "Manager USer password " $ManagerPassword
#echo "Manager USer Name " $ManagerUser
#echo "agent name " $AgentName
#echo "asset id " $AssetID
#echo "Verify option " $VerifyOption


echo "Launching registration..."
/esm/bin/`/esm/platform`/register -r $ManagerName $ManagerPassword $ManagerUser $AgentName $AssetID $VerifyOption 

echo "Patch process complete."
